/**************************************************************************
*  
*             ITU-T SOFTWARE TOOLS' GENERAL PUBLIC LICENSE                  
*
*  This "General Public License" is published in the Annex 1 of the
*  ITU-T Recommendation on "SOFTWARE TOOLS FOR HOMOGENITY OF RESULTS
*  IN THE STANDARDIZATION PROCESS OF SPEECH AND AUDIO CODERS",
*  approved in Geneva, 2000.
*
*  TERMS AND CONDITIONS
*
*  1. This License Agreement applies to any module or other work
*  related to the ITU-T Software Tool Library, and developed by the
*  User's Group on Software Tools. The "Module", below, refers to any
*  such module or work, and a "work based on the Module" means either
*  the Module or any work containing the Module or a portion of it,
*  either verbatim or with modifications.  Each licensee is addressed
*  as "you".
*
*  2. You may copy and distribute verbatim copies of the Module's
*  source code as you receive it, in any medium, provided that you:
*  -  conspicuously and appropriately publish on each copy an appropriate
*     copyright notice and disclaimer of warranty;
*  -  keep intact all the notices that refer to this General Public
*     License and to the absence of any warranty; and
*  -  give any other recipients of the Module a copy of this General
*     Public License along with the Module.
*  You may charge a fee for the physical act of transferring a copy.
*
*  3. You may modify your copy or copies of the Module or any portion
*  of it, and copy and distribute such modifications under the terms
*  of Paragraph 1 above, provided that you also do the following:
*
*      o  cause the modified files to carry prominent notices stating
*      that you changed the files and the date of any change; and
*
*      o  cause the whole of any work that you distribute or publish,
*      that in whole or in part contains the Module or any part
*      thereof, either with or without modifications, to be licensed
*      at no charge to all third parties under the terms of this
*      General Public License (except that you may choose to grant
*      warranty protection to some or all third parties, at your
*      option).
*
*      o  If the modified module normally reads commands interactively
*      when run, you must cause it, when started running for such
*      interactive use in the simplest and most usual way, to print or
*      display an announcement including an appropriate copyright
*      notice and a notice that there is no warranty (or else, saying
*      that you provide a warranty) and that users may redistribute
*      the module under these conditions, and telling the user how to
*      view a copy of this General Public License.
*
*  You may charge a fee for the physical act of transferring a copy,
*  and you may at your option offer warranty protection in exchange
*  for a fee.
*
*  Mere aggregation of another independent work with the Module (or
*  its derivative) on a volume of a storage or distribution medium
*  does not bring the other work under the scope of these terms.
*
*  4.  You may copy and distribute the Module (or a portion or
*  derivative of it, under Paragraph 2) in object code or executable
*  form under the terms of Paragraphs 1 and 2 above provided that you
*  also do one of the following:
*
*      o  accompany it with the complete corresponding machine-
*      readable source code, which must be distributed under the terms
*      of Paragraphs 1 and 2 above; or,
*
*      o  accompany it with a written offer, valid for at least three
*      years, to give any third party free (except for a nominal
*      charge for the cost of distribution) a complete machine-
*      readable copy of the corresponding source code, to be
*      distributed under the terms of Paragraphs 1 and 2 above; or,
*
*      o  accompany it with the information you received as to where
*      the corresponding source code may be obtained.  (This
*      alternative is allowed only for noncommercial distribution and
*      only if you received the module in object code or executable
*      form alone.) 
*
*  Source code for a work means the preferred form of the work for
*  making modifications to it.  For an executable file, complete
*  source code means all the source code for all modules it contains;
*  but, as a special exception, it need not include source code for
*  modules which are standard libraries that accompany the operating
*  system on which the executable file runs, or for standard header
*  files or definitions files that accompany that operating system.
*
*  5.  You may not copy, modify, sublicense, distribute or transfer
*  the Module except as expressly provided under this General Public
*  License. Any attempt otherwise to copy, modify, sublicense,
*  distribute or transfer the Module is void, and will automatically
*  terminate your rights to use the Module under this License. 
*  However, parties who have received copies, or rights to use copies,
*  from you under this General Public License will not have their
*  licenses terminated so long as such parties remain in full
*  compliance.
*
*  6.  By copying, distributing or modifying the Module (or any work
*  based on the Module) you indicate your acceptance of this license
*  to do so, and all its terms and conditions.
*
*  7.  Each time you redistribute the Module (or any work based on the
*  Module), the recipient automatically receives a license from the
*  original licensor to copy, distribute or modify the Module subject
*  to these terms and conditions.  You may not impose any further
*  restrictions on the recipients' exercise of the rights granted
*  herein.
*
*  8.  The ITU-T may publish revised and/or new versions of this
*  General Public License from time to time.  Such new versions will
*  be similar in spirit to the present version, but may differ in
*  detail to address new problems or concerns.
*
*  Each version is given a distinguishing version number. If the
*  Module specifies a version number of the license which applies to
*  it and "any later version", you have the option of following the
*  terms and conditions either of that version or of any later version
*  published by the ITU-T. If the Module does not specify a version
*  number of the license, you may choose any version ever published by
*  the ITU-T.
*
*  9.  If you wish to incorporate parts of the Module into other free
*  modules whose distribution conditions are different, write to the
*  author to ask for permission.  For software which is copyrighted by
*  the ITU-T, write to the ITU-T Secretariat; exceptions may be made
*  for this. This decision will be guided by the two goals of
*  preserving the free status of all derivatives of this free software
*  and of promoting the sharing and reuse of software generally.
*
*
*  NO WARRANTY
*
*  10. BECAUSE THE MODULE IS LICENSED FREE OF CHARGE, THERE IS NO
*  WARRANTY FOR THE MODULE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
*  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS
*  AND/OR OTHER PARTIES PROVIDE THE MODULE "AS IS" WITHOUT WARRANTY OF
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED
*  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND
*  PERFORMANCE OF THE MODULE IS WITH YOU.  SHOULD THE MODULE PROVE
*  DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR
*  OR CORRECTION.
*
*  11. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
*  WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
*  MODIFY AND/OR REDISTRIBUTE THE MODULE AS PERMITTED ABOVE, BE LIABLE
*  TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
*  CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
*  THE MODULE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
*  RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR
*  A FAILURE OF THE MODULE TO OPERATE WITH ANY OTHER MODULES), EVEN IF
*  SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES.
*
*  END OF TERMS AND CONDITIONS
***************************************************************************/
 
;------------------------------------------------------------------------------
;G726_quan function prototypes

/*short G726_quan_5(short dln, short ds);
short G726_quan_4(short dln, short ds);
short G726_quan_3(short dln, short ds);
short G726_quan_2(short dln, short ds);*/



;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
;Global Declarations:
;------------------------------------------------------------------------------
        .global _G726_quan_5
        .global _G726_quan_4
        .global _G726_quan_3
        .global _G726_quan_2

;------------------------------------------------------------------------------
;Code Section in Program Memory
;------------------------------------------------------------------------------ 
        .section libg726a, code

/******************************************************************************
*
*  Function Name:       G726_quan_5
*
*  System:              RISC
*
*  Platform:            dsPIC33F
*  
*  Description:         Quantize difference signal in logarithmic
*					    domain. Code rate-40Kbps
*                                            
*  Cycle Count:         29
*  
*  Input Parameters:    W0-dln 
*                       W1-ds   
*
*  Output Parameters:   W0-i
* 	  
*  History: 
*
*         Date    |        By         |   Remarks
*  ---------------+-------------------+----------------------------------		
*     Oct-20-2005  	Shridhar. D	        Created.
******************************************************************************/ 
.text
_G726_quan_5:
        sub     #339,W0
        bra     N, QUAN1
        sub     #136,W0
        bra     N,QUAN2
        sub     #53,W0
        bra     N,QUAN3
        sub     #25,W0
        bra     N,QUAN4
        mov     #15,W0
        bra     DSCOND
QUAN4:
        mov     #14,W0
        bra     DSCOND
QUAN3:
        add     #26,W0
        bra     N,QUAN5
        mov     #13,W0
        bra     DSCOND
QUAN5:
        mov     #12,W0
        bra     DSCOND
QUAN2:
        add     #62,W0
        bra     N, QUAN6
        sub     #32,W0
        bra     N, QUAN7
        mov     #11,w0
        bra     DSCOND
QUAN7:
        mov     #10,W0
        bra     DSCOND
QUAN6:
        add     #35,W0
        bra     N,QUAN8
        mov     #9,W0
        bra     DSCOND
QUAN8:
        mov     #8,W0
        bra     DSCOND
QUAN1:
        add     #271,W0
        bra     N,QUAN9
        sub     #130,W0
        bra     N,QUAN10
        sub     #52,W0
        bra     N,QUAN11
        sub     #48,W0
        bra     N,QUAN12
        mov     #7,W0
        bra     DSCOND
QUAN12:
        mov     #6,W0
        bra     DSCOND
QUAN11:
        mov     #5,W0
        bra     DSCOND
QUAN10:
        add     #59,W0
        bra     N,QUAN13
        mov     #4,W0
        bra     DSCOND
QUAN13:
        mov     #3,W0
        bra     DSCOND
QUAN9:
        neg		W0,W0
		sub		#0xBE, W0
		bra		GT,QUAN14
		add		#106,W0
		bra		GT,QUAN15
		mov     #0x2,W0
		bra     DSCOND
QUAN15:
        mov     #0x1,W0
        bra     DSCOND
QUAN14:
        mov     #0x1F,W0
DSCOND:
        cp0     W1
        bra     Z, DSCOND1 
        subR    W0,#0x1F,W0
DSCOND1:
        cp0     W0
        bra     NZ,DSCOND2
        mov     #0x1F,W0
DSCOND2:
        return


/******************************************************************************
*
*  Function Name:       G726_quan_4
*
*  System:              RISC
*
*  Platform:            dsPIC33F
*  
*  Description:         Quantize difference signal in logarithmic
*						domain.Code rate-32Kbps
*                                            
*  Cycle Count:         27
*  
*  Input Parameters:    W0-dln 
*                       W1-ds   
*
*  Output Parameters:   W0-i
* 	  
*  History: 
*
*         Date    |        By         |   Remarks
*  ---------------+-------------------+----------------------------------		
*     Oct-20-2005  	Shridhar. D	        Created.
******************************************************************************/

_G726_quan_4:
        sub     #246,W0
        bra     N,QUAN41
        sub     #103,W0
        bra     N,QUAN42
        sub     #51,W0
        bra     N,QUAN43
        mov     #0x7,W0
        bra     DSCOND4
QUAN43:
        mov     #0x6,W0
        bra     DSCOND4
QUAN42:
        add     #49,W0
        bra     N,QUAN44
        mov     #0x5,W0
        bra     DSCOND4
QUAN44:
        mov     #0x4,W0
        bra     DSCOND4
QUAN41:
        add		#370,W0
		bra		LT,QUAN45
		sub		#204,W0
		bra     N, QUAN46
        sub     #98,W0
        bra     N, QUAN47
        mov     #0x3,W0
        bra     DSCOND4
QUAN47:
        mov     #0x2,W0
        bra     DSCOND4
QUAN46:
        mov     #0x1,W0
        bra     DSCOND4
QUAN45:
        mov     #0xF,W0
DSCOND4:
        cp0     W1
        bra     Z, DSCOND41 
        subR    W0,#0xF,W0
DSCOND41:
        cp0     W0
        bra     NZ,DSCOND42
        mov     #0xF,W0
DSCOND42:
        return


/******************************************************************************
*
*  Function Name:       G726_quan_3
*
*  System:              RISC
*
*  Platform:            dsPIC33F
*  
*  Description:         Quantize difference signal in logarithmic
*						domain.Code rate-24Kbps
*                                            
*  Cycle Count:         22
*  
*  Input Parameters:    W0-dln 
*                       W1-ds   
*
*  Output Parameters:   W0-i
* 	  
*  History: 
*
*         Date    |        By         |   Remarks
*  ---------------+-------------------+----------------------------------		
*     Oct-21-2005  	Shridhar. D	        Created.
******************************************************************************/ 

_G726_quan_3:
        sub     #218,W0
        bra     N,QUAN31 
        sub     #113,W0
        bra     N, QUAN32
        mov     #0x3,W0
        bra     DSCOND3
QUAN32:
        mov     #0x2,W0
        bra     DSCOND3
QUAN31:
        add     #210, W0
        bra     LT,QUAN33
        mov     #0x1,W0
        bra     DSCOND3
QUAN33:
        mov     #0x7,W0
DSCOND3:
        cp0     W1
        bra     Z, DSCOND31 
        subR    W0,#0x7,W0
DSCOND31:
        cp0     W0
        bra     NZ,DSCOND32
        mov     #0x7,W0

DSCOND32:
        return


/******************************************************************************
*
*  Function Name:       G726_quan_2
*
*  System:              RISC
*
*  Platform:            dsPIC33F
*  
*  Description:         Quantize difference signal in logarithmic
*						domain.Code rate-16Kbps
*                                            
*  Cycle Count:         15
*  
*  Input Parameters:    W0-dln 
*                       W1-ds   
*
*  Output Parameters:   W0-i
* 	  
*  History: 
*
*         Date    |        By         |   Remarks
*  ---------------+-------------------+----------------------------------		
*     Oct-21-2005  	Shridhar. D	        Created.
******************************************************************************/

_G726_quan_2:
        sub     #0x105,W0
        bra     LT, QUAN21
        mov     #0x1,W0
        bra     DSCOND22
QUAN21:
        clr     W0
DSCOND22:
        cp0     W1
        bra     Z, DSCOND21
        subR    W0,#0x3,W0
DSCOND21:
        return


;--------End of All Code Sections ---------------------------------------------
.end                               ;End of program code in this file 

