// This file is part of parrocchetto.

// parrocchetto is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// parrocchetto is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with parrocchetto.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SPI1_H
#define	SPI1_H

#include <xc.h>
#include <stdint.h>

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

#define spi1_begin() (PORTBbits.RB7 = 0)
#define spi1_end() (PORTBbits.RB7 = 1)
#define spi1_read() spi1_write(0)

void spi1_init(void);
inline uint8_t spi1_write(uint8_t x);
inline void spi1_writebuf(const uint8_t* buf, uint16_t buf_size);
inline void spi1_readbuf(uint8_t* buf, uint16_t buf_size);

#ifdef	__cplusplus
}
#endif
#endif	// SPI1_H
